<?php
/***********************************************************************
| Cerb(tm) developed by Webgroup Media, LLC.
|-----------------------------------------------------------------------
| All source code & content (c) Copyright 2002-2015, Webgroup Media LLC
|   unless specifically noted otherwise.
|
| This source code is released under the Devblocks Public License.
| The latest version of this license can be found here:
| http://cerberusweb.com/license
|
| By using this software, you acknowledge having read this license
| and agree to be bound thereby.
| ______________________________________________________________________
|	http://www.cerbweb.com	    http://www.webgroupmedia.com/
***********************************************************************/
/*
 * IMPORTANT LICENSING NOTE from your friends on the Cerb Development Team
 *
 * Sure, it would be so easy to just cheat and edit this file to use the
 * software without paying for it.  But we trust you anyway.  In fact, we're
 * writing this software for you!
 *
 * Quality software backed by a dedicated team takes money to develop.  We
 * don't want to be out of the office bagging groceries when you call up
 * needing a helping hand.  We'd rather spend our free time coding your
 * feature requests than mowing the neighbors' lawns for rent money.
 *
 * We've never believed in hiding our source code out of paranoia over not
 * getting paid.  We want you to have the full source code and be able to
 * make the tweaks your organization requires to get more done -- despite
 * having less of everything than you might need (time, people, money,
 * energy).  We shouldn't be your bottleneck.
 *
 * We've been building our expertise with this project since January 2002.  We
 * promise spending a couple bucks [Euro, Yuan, Rupees, Galactic Credits] to
 * let us take over your shared e-mail headache is a worthwhile investment.
 * It will give you a sense of control over your inbox that you probably
 * haven't had since spammers found you in a game of 'E-mail Battleship'.
 * Miss. Miss. You sunk my inbox!
 *
 * A legitimate license entitles you to support from the developers,
 * and the warm fuzzy feeling of feeding a couple of obsessed developers
 * who want to help you get more done.
 *
 \* - Jeff Standen, Darren Sugita, Dan Hildebrandt
 *	 Webgroup Media LLC - Developers of Cerb
 */
class CerberusUtils {
	/**
	 * Enter description here...
	 *
	 * @param string $string
	 * @return array
	 */
	static function parseRfcAddressList($input) {
		$addys = array();
		
		if(!is_array($input))
			$input = array($input);
		
		foreach($input as $string) {
			$addy_rows = self::_parseRfcAddress($string);
			
			if(!empty($addy_rows))
				$addys = array_merge($addys, $addy_rows);
		}
		
		// If we failed to find any content, try a regexp parse
		if(empty($addys)) {
			foreach($input as $string) {
				if(preg_match('/[\\w\\.\\-+=*_]*@[\\w\\.\\-+=*_]*/', $string, $matches)) {
					if(is_array($matches))
					foreach($matches as $match) {
						$addy_rows = self::_parseRfcAddress($match);
						
						if(!empty($addy_rows))
							$addys = array_merge($addys, $addy_rows);
						
					}
				}
			}
		}

		@imap_errors();
		
		return $addys;
	}
	
	static private function _parseRfcAddress($string) {
		@$addy_rows = imap_rfc822_parse_adrlist($string, '');
		$results = array();
		
		if(is_array($addy_rows))
		foreach($addy_rows as $idx => $addy_row) {
			if(empty($addy_row->host))
				continue;
		
			if($addy_row->host == '.SYNTAX-ERROR.')
				continue;
			
			if(strlen($addy_row->mailbox) == 1 && preg_match('/[^a-zA-Z0-9]/', $addy_row->mailbox))
				continue;
			
			$results[] = $addy_row;
		}
		
		@imap_errors();
		
		return $results;
	}
	
}