<?php
$db = DevblocksPlatform::getDatabaseService();
$tables = $db->metaTables();
$prefix = (APP_DB_PREFIX != '') ? APP_DB_PREFIX.'_' : '';

// ===========================================================================
// Expand the description column on the plugin table

list($columns, $indexes) = $db->metaTable($prefix.'plugin');

if(!isset($columns['description']))
	return FALSE;

if(substr(strtolower($columns['description']['type']),0,7) == 'varchar') {
	$db->ExecuteMaster("ALTER TABLE ${prefix}plugin MODIFY COLUMN description TEXT");
}

// ===========================================================================
// devblocks_storage_deletes

if(!isset($tables['devblocks_storage_queue_delete'])) {
	$sql = sprintf("
		CREATE TABLE IF NOT EXISTS devblocks_storage_queue_delete (
			storage_namespace VARCHAR(64) NOT NULL DEFAULT '',
			storage_key VARCHAR(255) NOT NULL DEFAULT '',
			storage_extension VARCHAR(128) NOT NULL DEFAULT '',
			storage_profile_id INT UNSIGNED NOT NULL DEFAULT 0,
			INDEX ns_ext_profile (storage_namespace, storage_extension, storage_profile_id)
		) ENGINE=%s;
	", APP_DB_ENGINE);
	$db->ExecuteMaster($sql);

	$tables['devblocks_storage_queue_delete'] = 'devblocks_storage_queue_delete';
}

return TRUE;